import socket, sys
from time import sleep, time
from Queue import Queue

# ew...
def getIP():
	s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	s.connect(('91.121.94.180', 80)) # doesn't matter if it fails
	addr = s.getsockname()[0] 
	s.close()
	return addr

class PdLANPoller:
	"""
		Broadcasts our IP address every two seconds.
		It's the poor GNU programmer's Bonjour! :)
		Also has the ability to broadcast stuff queued up with 
	"""
	def __init__(self):
		self.queue = Queue()
	
	def Launch(self):
		# socket and address for doing UDP broadcast
		dest = ('255.255.255.255', 10314)
		s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
		s.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
		
		# elapsed time
		last = 0
		
		# what IP address the server is listening on
		if len(sys.argv) == 2:
			addr = sys.argv[1]
		else:
			addr = getIP()
		print "Listening on", addr
		print "(You can specify this with an argument)"
		
		try:
			while 1:
				# broadcast the server IP address every two seconds
				if last < time() - 2:
					print 'broacasting ip...'
					s.sendto("ip %s;\n" % addr, dest)
					last = time()
				# if we have UDP messages queued, then send them too
				while not self.queue.empty():
					send = self.queue.get()
					print " ".join(send)
					s.sendto("%s;\n" % " ".join(send), dest)
				sleep(0.001)
		except KeyboardInterrupt:
			sys.exit(0)
	
	def Post(self, data):
		""" Broadcast this array to all clients on the LAN. """
		self.queue.put(data)

if __name__ == "__main__":
	import threading
	try:
		poller = PdLANPoller()
		poller.Post(["my", "first", "test"])
		threadSrv = threading.Thread(target=poller.Launch)
		threadSrv.start()
		sleep(2.5)
		while 1:
			poller.Post(["this", "is", "just", "a", "test"])
			sleep(1.5)
	except KeyboardInterrupt:
		sys.exit(0)
